<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: menu_maint.php,v 1.14 2011/01/12 16:37:44 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class menu_maint
{
	public $u_action;

	private $menu_todo = array(
		'extension'		=> 'DIAL_EXT',
		'repeat'		=> 'REPEAT_MENU',
		'gotovm'		=> 'LEAVE_VM',
		'checkvm'		=> 'CHECK_VM',
		'gotomenu'		=> 'GOTO_MENU',
		'directory'		=> 'COMPANY_DIR',
		'playinvalid'	=> 'PLAY_INVALID',
		'hangup'		=> 'HANGUP',
		'queue'			=> 'GOTO_WORKGROUP',
		'unassigned'	=> 'UNASSIGNED'
	);
	
	// Page Variable Defaults
	private $menu_access_num = 0;
	private $menu_name = '';
	private $response_timeout = 15;
	private $interdigit_timeout = 5;
	
	private $external_access = false;
	private $direct_ext_dial = false;
	private $is_dial_by_first = false;
	
	private $menu_password = '4321';
	
	private $todo_0 = 'unassigned';
	private $todo_1 = 'unassigned';
	private $todo_2 = 'unassigned';
	private $todo_3 = 'unassigned';
	private $todo_4 = 'unassigned';
	private $todo_5 = 'unassigned';
	private $todo_6 = 'unassigned';
	private $todo_7 = 'unassigned';
	private $todo_8 = 'unassigned';
	private $todo_9 = 'unassigned';
	private $todo_10 = 'unassigned';
	private $todo_11 = 'unassigned';
	
	private $wg_0 = '';
	private $wg_1 = '';
	private $wg_2 = '';
	private $wg_3 = '';
	private $wg_4 = '';
	private $wg_5 = '';
	private $wg_6 = '';
	private $wg_7 = '';
	private $wg_8 = '';
	private $wg_9 = '';
	private $wg_10 = '';
	private $wg_11 = '';
	
	private $menu_0 = '';
	private $menu_1 = '';
	private $menu_2 = '';
	private $menu_3 = '';
	private $menu_4 = '';
	private $menu_5 = '';
	private $menu_6 = '';
	private $menu_7 = '';
	private $menu_8 = '';
	private $menu_9 = '';
	private $menu_10 = '';
	private $menu_11 = '';
	
	private $ext_0 = '';
	private $ext_1 = '';
	private $ext_2 = '';
	private $ext_3 = '';
	private $ext_4 = '';
	private $ext_5 = '';
	private $ext_6 = '';
	private $ext_7 = '';
	private $ext_8 = '';
	private $ext_9 = '';
	private $ext_10 = '';
	private $ext_11 = '';
	
	private $mailbox_0 = '';
	private $mailbox_1 = '';
	private $mailbox_2 = '';
	private $mailbox_3 = '';
	private $mailbox_4 = '';
	private $mailbox_5 = '';
	private $mailbox_6 = '';
	private $mailbox_7 = '';
	private $mailbox_8 = '';
	private $mailbox_9 = '';
	private $mailbox_10 = '';
	private $mailbox_11 = '';
	
	function main($id, $mode)
	{
		global $user, $template, $soap, $common_path, $phpEx;
		$action = request_var('action', '');
		$s_hidden_fields = '';
		//validation of required field
		if (post_var('validate_data'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			
			$acces_num = request_var('menu_access_num', '' );
			
			$validate_ary = array(
				'menu_name'				=> request_var('menu_name',  ''),
				'menu_access_num'		=> $acces_num ,
			);
			$error = validate_data($validate_ary, array(
				'menu_name'			=> array(
					array('string', false, 1, 19 - strlen($user->data['cust_id']))),
				'menu_access_num'			=> array(
					array('string', false, 1, 32))
			));
			return_error_data($error);
		}
		if ( post_var('add_menu') || post_var('edit_menu') )
		{
			$has_error = false;
			$menu = $this->fetch_menu($has_error);
			if ( $has_error )
			{
				if ( post_var('add_menu') )
				{
					$action = 'add';
				}
				else 
				{
					$action = 'edit';
				}
			}
			else
			{
				$status = 'voicemail';
				$soap->send(SAVE_AA_DIALOG, array($menu), $status, false, false, true);
				confirmation_box($status, 'AA_MENU_SAVED');
				$action = '';	
			}
		}

		switch ($action)
		{
			case 'add':
				$this->display_menu();
				$template->assign_vars( array ( 
					'S_ADD' 			=> true,
					'MAX_LENGTH'		=> 19 - strlen($user->data['cust_id']),
				));
				break;
			case 'delete':
				$this->menu_name = request_var('dialogname', '');	
				
				if ( strlen($this->menu_name) > 0 )
				{
					$status = 'voicemail';
					$result = $soap->send(DELETE_AA_DIALOG, array($user->data['cust_id'], $this->menu_name), $status, false, false, true);
					confirmation_box($status, 'AA_DELETED');
				}
				break;
			case 'edit':
				if ( strlen($this->menu_name) <= 0 )
				{
					$this->menu_name = request_var('dialogname', '');	
				}
				
				if ( strlen($this->menu_name) > 0 )
				{
					$status = 'voicemail';
					$result = $soap->send(GET_AA_DIALOG, array($user->data['cust_id'], $this->menu_name), $status, true);
					$this->display_menu($result);
					
					$template->assign_vars( array ( 
						'S_EDIT' 			=> true,
					));
				}
				else 
				{
					confirmation_box(array('status' => '', 'error_message' => $user->lang['EDIT_FAILED']), 'EDIT_FAILED');
				}
				break;
		}
		
		$status = 'voicemail';
		$result = $soap->send(GET_AA_MENU_LIST, array($user->data['cust_new_id']), $status);

		foreach ($result as $row) {
			$template->assign_block_vars('menus', array(
				'DIALOG_NAME'	=> $row['dialogname'],
			
				'U_EDIT_LINK'	=> $this->u_action.'&amp;action=edit&amp;dialogname='.$row['dialogname'],
				'U_DELETE_LINK'	=> $this->u_action.'&amp;action=delete&amp;dialogname='.$row['dialogname'],
			));
		}
		
		$s_hidden_fields .= build_hidden_fields(array(
		));
		
		$template->assign_vars(array(
			'U_ADD_LINK'		=> $this->u_action.'&amp;action=add',
		
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
		
			'MAX_NAME_FIELD_LIM'	=> 19 - strlen($user->data['cust_id']),
		
			'U_ACTION'			=> $this->u_action
		));
	}
	
	function gen_timeout_options($start, $end, $current = 15)
	{
		$options = '';
		for ($i = $start; $i <= $end; $i++ )
		{
			$options .= '<option value="'.$i.'" '.(($i == $current)?'selected':'').'>' . $i. '</option>';
		}
		return $options;
	}
	
	function gen_todo_options($current = 'unassigned')
	{
		global $user;
		
		$options = '';
		foreach ($this->menu_todo as $value => $lang) {
			$options .= '<option value="'.$value.'" '.(($current == $value)?'selected':'').'>' . $user->lang[$lang] . "</option>";
		}
		
		return $options;
	}
	
	function gen_wg_options($current = '')
	{
		global $user, $soap;
		
		$status = 'entice';
		$result = $soap->send(GET_WORKGROUPS, array($user->data['cust_id']), $status);
		
		$options = '';
		foreach ($result as $row)
		{
			$options .= '<option value="'.$row['group_id'].'" '.(($current == $row['group_id'])?'selected':'').'>' . $row['s_desc'] . '</option>';
		}
		if ( strlen($options) == 0 )
		{
			$options = '<option value="" >'.$user->lang['NO_WORKGROUPS'].'</option>';
		}
		
		return $options;
	}
	
	function gen_menu_options($current = '')
	{
		global $user, $soap;
		
		$status = 'voicemail';
		$result = $soap->send(GET_AA_MENU_LIST, array($user->data['cust_new_id']), $status);
		$options = '';
		foreach ($result as $row)
		{
			$options .= '<option value="'.$row['dialogname'].'" '.(($current == $row['dialogname'])?'selected':'').'>' . $row['dialogname'] . '</option>';
			
		}
		if ( strlen($options) == 0 )
		{
			$options = '<option value="" >'.$user->lang['NO_AUTO_ATTENDANT_MENUS'].'</option>';
		}
		
		return $options;
	}
	
	function gen_ext_options($current = '', $has_vm = false)
	{
		global $user, $soap;
		
		$filter = 'TYPE = "EXT"';
		$lang_err = 'NO_EXT_AVAIL';
		if ($has_vm)
		{
			$filter .= ' and hasMailBox = "true"';
			$lang_err = 'NO_MAILBOX_AVAIL';
		}
		
		$status = 'billing3';
		$result = $soap->send(GET_PHONE_NUMBERS, array($user->data['cust_id'], $user->data['acct_id']), $status, false, true);
		$options = '';
		$result = $result->xpath('//row['.$filter.']/NUMBER');
		if ( $result ) {
			foreach ($result as $row)
			{
				$options .= '<option value="'.(string)$row.'" '.(($current == (string)$row)?'selected':'').'>' . (string)$row . '</option>';
				
			}
		}
		if ( strlen($options) == 0 )
		{
			$options = '<option value="" >'.$user->lang[$lang_err].'</option>';
		}
		
		return $options;
	}
	
	function display_menu($menu = array())
	{
		global $template, $user;
		
		if (sizeof($menu))
		{
			$this->menu_access_num = $menu->accessNumber;
			$this->menu_name = $menu->dialogName;
			$this->response_timeout = $menu->waitForResponseSec;
			$this->interdigit_timeout = $menu->waitForKeyPressSec;
			$this->direct_ext_dial = $menu->isDialingExtensionsAllowed;
			$this->external_access = $menu->isAccessNumberDID;
			$this->is_dial_by_first = $menu->isFirstNameDial;
			$this->menu_password = $menu->password;
			
			
			for ($i = 0;$i <= 11; $i++) {
				$id = $menu->aaDialogSelections[$i]->selection;
				$td = 'todo_'.$id;
				$xt = 'ext_'.$id;
				$mb = 'mailbox_'.$id;
				$wg = 'wg_'.$id;
				$mu = 'menu_'.$id;
				
				$this->$td = $menu->aaDialogSelections[$i]->task;
				switch ($this->$td)
				{
					case 'extension':
						$this->$xt = $menu->aaDialogSelections[$i]->data;
						$this->$mb = '';
						$this->$wg = '';
						$this->$mu = '';
						$template->assign_var('SHOW_EXT_'.$id, true);
						break;
					case 'gotomenu' : 
						$this->$xt = '';
						$this->$mb = '';
						$this->$wg = '';
						$this->$mu = $menu->aaDialogSelections[$i]->data;
						$template->assign_var('SHOW_MENU_'.$id, true);
						break;
					case 'gotovm' : 
						$this->$xt = '';
						$this->$mb = $menu->aaDialogSelections[$i]->data;
						$this->$wg = '';
						$this->$mu = '';
						$template->assign_var('SHOW_MAILBOX_'.$id, true);
						break;
					case 'queue' : 
						$this->$xt = '';
						$this->$mb = '';
						$this->$wg = $menu->aaDialogSelections[$i]->data;
						$this->$mu = '';
						$template->assign_var('SHOW_WG_'.$id, true);
						break;
					default:
						$this->$xt = '';
						$this->$mb = '';
						$this->$wg = '';
						$this->$mu = '';
						break;
				}
			}
		}
		
		if ($user->data['managed_did']){
			// create did list for this customer
			$opts = getDIDSelect($user->data['cust_id'], ($this->menu_access_num)?$this->menu_access_num:'', false, true);
			$template->assign_vars(array(
				'DID_OPTIONS' => $opts,
				'MANAGED_DID' => true,
			));
		}
		
		$template->assign_vars( array ( 
			'MENU_NAME'			=> $this->menu_name,
			'MENU_ACCESS_NUM'	=> ($this->menu_access_num)?$this->menu_access_num:'',
		
			'RESPONSE_TIMEOUT_OPTIONS'		=> $this->gen_timeout_options(0, 30, $this->response_timeout),
			'INTERDIGIT_TIMEOUT_OPTIONS'	=> $this->gen_timeout_options(0, 10, $this->interdigit_timeout),

			'EXTERNAL_ACCESS'	=> $this->external_access,
			'DIRECT_EXT_DIAL'	=> $this->direct_ext_dial,
		
			'IS_DIAL_BY_FIRST'	=> $this->is_dial_by_first,
			'MENU_PASSWORD'		=> $this->menu_password,
		
			'TODO_0_OPTIONS'	=> $this->gen_todo_options($this->todo_0),
			'TODO_1_OPTIONS'	=> $this->gen_todo_options($this->todo_1),
			'TODO_2_OPTIONS'	=> $this->gen_todo_options($this->todo_2),
			'TODO_3_OPTIONS'	=> $this->gen_todo_options($this->todo_3),
			'TODO_4_OPTIONS'	=> $this->gen_todo_options($this->todo_4),
			'TODO_5_OPTIONS'	=> $this->gen_todo_options($this->todo_5),
			'TODO_6_OPTIONS'	=> $this->gen_todo_options($this->todo_6),
			'TODO_7_OPTIONS'	=> $this->gen_todo_options($this->todo_7),
			'TODO_8_OPTIONS'	=> $this->gen_todo_options($this->todo_8),
			'TODO_9_OPTIONS'	=> $this->gen_todo_options($this->todo_9),
			'TODO_10_OPTIONS'	=> $this->gen_todo_options($this->todo_10),
			'TODO_11_OPTIONS'	=> $this->gen_todo_options($this->todo_11),
		
			'WORKGROUP_0_OPTIONS'	=> $this->gen_wg_options($this->wg_0),
			'WORKGROUP_1_OPTIONS'	=> $this->gen_wg_options($this->wg_1),
			'WORKGROUP_2_OPTIONS'	=> $this->gen_wg_options($this->wg_2),
			'WORKGROUP_3_OPTIONS'	=> $this->gen_wg_options($this->wg_3),
			'WORKGROUP_4_OPTIONS'	=> $this->gen_wg_options($this->wg_4),
			'WORKGROUP_5_OPTIONS'	=> $this->gen_wg_options($this->wg_5),
			'WORKGROUP_6_OPTIONS'	=> $this->gen_wg_options($this->wg_6),
			'WORKGROUP_7_OPTIONS'	=> $this->gen_wg_options($this->wg_7),
			'WORKGROUP_8_OPTIONS'	=> $this->gen_wg_options($this->wg_8),
			'WORKGROUP_9_OPTIONS'	=> $this->gen_wg_options($this->wg_9),
			'WORKGROUP_10_OPTIONS'	=> $this->gen_wg_options($this->wg_10),
			'WORKGROUP_11_OPTIONS'	=> $this->gen_wg_options($this->wg_11),
		
			'MENU_0_OPTIONS'	=> $this->gen_menu_options($this->menu_0),
			'MENU_1_OPTIONS'	=> $this->gen_menu_options($this->menu_1),
			'MENU_2_OPTIONS'	=> $this->gen_menu_options($this->menu_2),
			'MENU_3_OPTIONS'	=> $this->gen_menu_options($this->menu_3),
			'MENU_4_OPTIONS'	=> $this->gen_menu_options($this->menu_4),
			'MENU_5_OPTIONS'	=> $this->gen_menu_options($this->menu_5),
			'MENU_6_OPTIONS'	=> $this->gen_menu_options($this->menu_6),
			'MENU_7_OPTIONS'	=> $this->gen_menu_options($this->menu_7),
			'MENU_8_OPTIONS'	=> $this->gen_menu_options($this->menu_8),
			'MENU_9_OPTIONS'	=> $this->gen_menu_options($this->menu_9),
			'MENU_10_OPTIONS'	=> $this->gen_menu_options($this->menu_10),
			'MENU_11_OPTIONS'	=> $this->gen_menu_options($this->menu_11),
		
			'EXT_0_OPTIONS'		=> $this->gen_ext_options($this->ext_0),
			'EXT_1_OPTIONS'		=> $this->gen_ext_options($this->ext_1),
			'EXT_2_OPTIONS'		=> $this->gen_ext_options($this->ext_2),
			'EXT_3_OPTIONS'		=> $this->gen_ext_options($this->ext_3),
			'EXT_4_OPTIONS'		=> $this->gen_ext_options($this->ext_4),
			'EXT_5_OPTIONS'		=> $this->gen_ext_options($this->ext_5),
			'EXT_6_OPTIONS'		=> $this->gen_ext_options($this->ext_6),
			'EXT_7_OPTIONS'		=> $this->gen_ext_options($this->ext_7),
			'EXT_8_OPTIONS'		=> $this->gen_ext_options($this->ext_8),
			'EXT_9_OPTIONS'		=> $this->gen_ext_options($this->ext_9),
			'EXT_10_OPTIONS'	=> $this->gen_ext_options($this->ext_10),
			'EXT_11_OPTIONS'	=> $this->gen_ext_options($this->ext_11),
		
			'MAILBOX_0_OPTIONS'		=> $this->gen_ext_options($this->mailbox_0, true),
			'MAILBOX_1_OPTIONS'		=> $this->gen_ext_options($this->mailbox_1, true),
			'MAILBOX_2_OPTIONS'		=> $this->gen_ext_options($this->mailbox_2, true),
			'MAILBOX_3_OPTIONS'		=> $this->gen_ext_options($this->mailbox_3, true),
			'MAILBOX_4_OPTIONS'		=> $this->gen_ext_options($this->mailbox_4, true),
			'MAILBOX_5_OPTIONS'		=> $this->gen_ext_options($this->mailbox_5, true),
			'MAILBOX_6_OPTIONS'		=> $this->gen_ext_options($this->mailbox_6, true),
			'MAILBOX_7_OPTIONS'		=> $this->gen_ext_options($this->mailbox_7, true),
			'MAILBOX_8_OPTIONS'		=> $this->gen_ext_options($this->mailbox_8, true),
			'MAILBOX_9_OPTIONS'		=> $this->gen_ext_options($this->mailbox_9, true),
			'MAILBOX_10_OPTIONS'	=> $this->gen_ext_options($this->mailbox_10, true),
			'MAILBOX_11_OPTIONS'	=> $this->gen_ext_options($this->mailbox_11, true)
		));
	}
	
	function fetch_menu(&$has_error)
	{
		global $user;
		
		$aa_menu = new AA_Dialog();
		$aa_menu->custId = $user->data['cust_id'];
		$aa_menu->custNewId = $user->data['cust_new_id'];
		
		$aa_menu->dialogName = str_replace(' ', '', request_var('menu_name', ''));
		if (strlen($aa_menu->dialogName) <= 0)
		{
			$has_error = true;
			confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_MENU_NAME']), 'NO_MENU_NAME');
		}
		$acces_num = request_var('menu_access_num', '');
		$aa_menu->accessNumber = $acces_num;
		if (strlen($aa_menu->accessNumber) <= 0)
		{
			$has_error = true;
			confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_ACCESS_NUMBER']), 'NO_MENU_NAME');
		}		
		
		$aa_menu->waitForResponseSec = request_var('response_timeout', 0);
		$aa_menu->waitForKeyPressSec = request_var('interdigit_timeout', 0);
		$aa_menu->isDialingExtensionsAllowed = request_var('direct_ext_dial', false);
		$aa_menu->isAccessNumberDID = request_var('enable_external_access', false);
		
		$aa_menu->isFirstNameDial = request_var('is_dial_by_first', false);
		$aa_menu->password = request_var('menu_password', '4321');
		
		for ($i = 0; $i <= 11; $i++ )
		{
			$sect = new AutoAttendantDialogSelection();
			$sect->selection = $i;
			$sect->task = request_var('todo_'.$i, '');
			switch ($sect->task)
			{
				case 'extension':
					$to_ext = request_var('ext_'.$i, 0);
					if ( !$to_ext ) 
					{
						$has_error = true;
						confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_EXT']), 'NO_EXT', (string)$i);
					}
					else 
					{
						$sect->data = $to_ext;
					}
					break;
				case 'gotomenu' : 
					$to_menu = request_var('menu_'.$i, '');
					if ( strlen($to_menu) <= 0 ) 
					{
						$has_error = true;
						confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_MENU']), 'NO_MENU', (string)$i);
					}
					else 
					{
						$sect->data = $to_menu;
					}
					break;
				case 'gotovm' : 
					$to_vm = request_var('mailbox_'.$i, 0);
					if ( !$to_vm ) 
					{
						$has_error = true;
						confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_VM']), 'NO_VM', (string)$i);
					}
					else 
					{
						$sect->data = $to_vm;
					}
					break;
				case 'queue' : 
					$to_queue = request_var('workgroup_'.$i, 0);
					if ( !$to_queue ) 
					{
						$has_error = true;
						confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_QUEUE']), 'NO_QUEUE', (string)$i);
					}
					else 
					{
						$sect->data = $to_queue;
					}
					break;
			}
			if(strlen($sect->task) > 0 ) 
			{
				array_push($aa_menu->aaDialogSelections, $sect);
			}
		}
		return ($aa_menu);
	}
}

class AA_Dialog {
     public $custId;
     public $custNewId;
     public $dialogName;
     public $accessNumber=false;
     public $description;
     public $isAccessNumberDID=false;
     public $voicePromptDescription;
     public $voicePromptWaveFileName;
     public $waitForResponseSec=15;
     public $waitForKeyPressSec=5;
     public $isDialingExtensionsAllowed=false;
     public $aaDialogSelections = array();
     public $password = "4321";
	 public $isFirstNameDial = false;
	
	public function __construct( $aa_dialog = null) {
        if ( null != $aa_dialog ) {
			$this->custId = $aa_dialog->custId;
	        $this->custNewId = $aa_dialog->custNewId;
	        $this->dialogName = $aa_dialog->dialogName;
	        $this->accessNumber = $aa_dialog->accessNumber;
	        $this->isAccessNumberDID = $aa_dialog->isAccessNumberDID;
	        $this->voicePromptDescription = $aa_dialog->voicePromptDescription;
	        $this->voicePromptWaveFileName = $aa_dialog->voicePromptWaveFileName;
	        $this->waitForResponseSec = $aa_dialog->waitForResponseSec;
	        $this->waitForKeyPressSec = $aa_dialog->waitForKeyPressSec;
	        $this->isDialingExtensionsAllowed = $aa_dialog->isDialingExtensionsAllowed;
	        $this->aaDialogSelections = $aa_dialog->aaDialogSelections;
	        $this->soapReturn = $aa_dialog->soapReturn;
	        $this->password = $aa_dialog->password;
	        $this->isFirstNameDial = $aa_dialog->isFirstNameDial;
        }
    }
     
    
    /**
     * get an AutoAttendantDialogSelection
     *
     * @param int $selection
     * @return AutoAttendantDialogSelection for the specified selection.
     */
    public function getSelection($selection){
       if ( isset($this->aaDialogSelections)) {
           foreach ($this->aaDialogSelections as $aaSect) {
              if ($aaSect->selection == $selection)	{
                  return $aaSect;
              }
           }
       }
       return new AutoAttendantDialogSelection();
    }

    public function myClone() {
        $rtrn = new AutoAttendantDialog();
        $rtrn->custId = $this->custId;
        $rtrn->custNewId = $this->custNewId;
        $rtrn->dialogName = $this->dialogName;
        $rtrn->accessNumber = $this->accessNumber;
        $rtrn->isAccessNumberDID = $this->isAccessNumberDID;
        $rtrn->voicePromptDescription = $this->voicePromptDescription;
        $rtrn->voicePromptWaveFileName = $this->voicePromptWaveFileName;
        $rtrn->waitForResponseSec = $this->waitForResponseSec;
        $rtrn->waitForKeyPressSec = $this->waitForKeyPressSec;
        $rtrn->isDialingExtensionsAllowed = $this->isDialingExtensionsAllowed;
        $rtrn->aaDialogSelections = $this->aaDialogSelections;
        $rtrn->password = $this->password;
	    $rtrn->isFirstNameDial = $this->isFirstNameDial;
        $rtrn->soapReturn = null;
        return $rtrn;
    }
}

class AutoAttendantDialogSelection {
   /** int */
    public $selection;
   /** string */
    public $task = "";
   /** string */
    public $data;

    public function __construct() {
    }
}

?>