<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: cid_map.php,v 1.6 2010/01/26 20:08:17 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class cid_map
{
	public $u_action;

	function main($id, $mode)
	{
		global $user, $template, $soap, $user_role;
		
		$part_id = $user->data['cust_id'];
		
		$cur_rani = request_var('rani', '');
		$cur_did = request_var('did', '');
		$s_hidden_fields = '';
		
		$action = request_var('action', '');

		$soap_user_id = get_soap_user_id();
		
		switch ($action)
		{
			case 'add':
				$rgId = $user->data['cust_id'];
				$partition = $user->data['cust_id'];
				
				if ( $cur_rani != '' )
				{
					if ( $cur_did != '')
					{
						$clg_tran_ary = array(
							'*@'.$cur_rani,
							$cur_did,
							$rgId,
							$partition,
							'',
							$soap_user_id,
							''
						);
						$status = 'entice';
						$result = $soap->send(ADD_CLG_TRAN, $clg_tran_ary, $status);
						confirmation_box($status, 'ANI_MAPPING_ADDED');
					}	
					else 
					{
						confirmation_box(array('status' => '', 'error_message' => $user->lang['ASSIGN_DID_ERR']), 'ASSIGN_DID_ERR');
					}
				}
				else
				{
					confirmation_box(array('status' => '', 'error_message' => $user->lang['DIAL_PLAN_ERR']), 'DIAL_PLAN_ERR');
				}
				break;
				
//			case 'edit':
//					// Have to have updateCallingTranslation call from SOAP
//				break;
			
			case 'delete':
				$rgId = $user->data['cust_id'];
				$partition = $user->data['cust_id'];
				$key_tag = request_var('key_tag', '');
				$rqst_ary = array(
					$key_tag,
					$rgId,
					$partition
				);
				$status = 'entice';
				$result = $soap->send(DELETE_CLG_TRAN, $rqst_ary, $status, false, false, true);
				confirmation_box($status, 'ANI_MAPPING_DELETED');
				break;
		}

		// Display Stuff
		$status = 'entice';
		$result = $soap->send(GET_CLG_TRANS, array('', $part_id, $part_id), $status, false, true, true);
		$used_anis = array();
		if ( !$result->error )
		{
			$result = $result->data->row;
			foreach ($result as $row) 
			{
				if ( strncmp($row->CALLING_NUMBER, '*@', strlen('*@')) == 0 )
				{
					display_vars($row, 'ani_maps');
					$split = split('@', $row->CALLING_NUMBER);
					$used_anis[] = $split[1];
				}
			}
		}
		
		$s_hidden_fields .= build_hidden_fields(array(
			'action'		=> '',
			'key_tag'		=> '',
		));
						
		$template->assign_vars(array(
			'RANI_OPTIONS'		=> $this->gen_rani_options($part_id, $used_anis, $cur_rani),
			'DID_OPTIONS'		=> $this->gen_did_options($cur_did),
		
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
		
			'U_ACTION'			=> $this->u_action
		));
	}
	
	function gen_rani_options($part_id, $used_anis = array(), $selected = '')
	{
		global $soap;
		
		$status = 'entice';
		$result = $soap->send(GET_TRANS_BY_PART, array($part_id), $status, false, true, true);
		
		$options = '';
		if ( !$result->error )
		{
			$result = $result->xpath('//row[RAN_PARTITION != ""]');
			$options_array = array();
			foreach ($result as $row) 
			{
				$options_array[] = (String)$row->RAN_PARTITION;
			}
			
			$options_array = array_unique($options_array);
			
			foreach ($options_array as $val) 
			{
				if ( !in_array($val, $used_anis) )
				{
					$options .= '<option value="'.$val.'" '.(($selected == $val)?'selected':'').'>' . $val . "</option>";
				}
			}
		}
		
		return $options;
	}
	
	function gen_did_options($selected = '')
	{
		global $soap, $user;
		
		$status = 'billing';
		$result = $soap->send('getDidByCustomerId', array($user->data['cust_id'], 2), $status, false, true);
		
		$options = '';
		if ( !$result->error )
		{
			$result = $result->data->row;
			foreach ($result as $row) 
			{
				$options .= '<option value="'.(string)$row->DID_NUMBER.'" '.(($selected == (string)$row->DID_NUMBER)?'selected':'').'>' . (string)$row->DID_NUMBER . "</option>";
			}
		}
		
		return $options;
	}
}
?>