<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: paging_groups.php,v 1.2 2009/05/12 21:24:28 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class paging_groups
{
	public $u_action;

	function main($id, $mode)
	{
		global $user, $template, $soap, $common_path, $phpEx;
		
		$action = request_var('action', '');
		$s_hidden_fields = '';
		
		//validation of required field
		if ( post_var('validate_data') )
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			$validate_ary = array(
				'group_name'			=> request_var('group_name',  ''),
				'access_number'			=> request_var('access_number',  ''),
			);
			$error = validate_data($validate_ary, array(
				'group_name'			=> array(
					array('string', false, 1, 128)),
				'access_number'			=> array(
					array('string', false, 1, 128)),
			));
			return_error_data($error);
			return;
		}
		else
		{
			if ( post_var('add_paging_group') )
			{
				$xmlAddGroup = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
				$data = $xmlAddGroup->addChild("data");
				$row = $data->addChild("row");
				$row->addChild("CUST_ID", $user->data['cust_id']);
				$row->addChild("GROUP_NAME", request_var('group_name', ''));
				$row->addChild("ACCESS_NUMBER", request_var('access_number', ''));
				
				$status = 'voicemail';
				$result = $soap->send(ADD_PAGING_GROUP, $xmlAddGroup->asXML(), $status, false, false, true);
				if ( $status['error'] )
				{
					$template->assign_vars(array(
						"GROUP_NAME", request_var('group_name', ''),
						"ACCESS_NUMBER", request_var('access_number', ''),
					));
				}
				confirmation_box($status, 'PAGING_GROUP_ADDED');
			}
			else if ( post_var('edit_paging_group') )
			{
				$group = request_var('group_id', -1);
				$status = 'voicemail';
				$result = $soap->send(GET_PAGING_GROUP, array($group), $status, false, true);
				if ( sizeof($result) )
				{
					$xmlPagingGroup = $result->data;
					$xmlPagingGroup->row->GROUP_NAME = request_var('group_name', '');
					$xmlPagingGroup->row->ACCESS_NUMBER = request_var('access_number', '');
					$status = 'voicemail';
					$result = $soap->send(UPDATE_PAGING_GROUP, array('<EnticeRequest>'.$xmlPagingGroup->asXML().'</EnticeRequest>'), $status, false, false, true);
					if ( $status['error'] )
					{
						$template->assign_vars(array(
							"GROUP_NAME", request_var('group_name', ''),
							"ACCESS_NUMBER", request_var('access_number', ''),
						));
					}
				}
				confirmation_box($status, 'PAGING_GROUP_UPDATED');
			}
			else if ( post_var('delete_paging_group') && request_var('delete_paging_group', false) )
			{
				$group = request_var('group_id', -1);
				$status = 'voicemail';
				$result = $soap->send(DELETE_PAGING_GROUP, array($group), $status, false, false, true);
				confirmation_box($status, 'PAGING_GROUP_DELETED');
			}
			
			$s_hidden_fields .= build_hidden_fields(array(
				'group_id'				=> '',
				'delete_paging_group'	=> false,
			));
			
			$template->assign_vars(array(
				'S_HIDDEN_FIELDS'	=> $s_hidden_fields,

				'U_AJAX_ACTION'		=> $this->u_action.'&amp;action=ajax',
				'U_ACTION'			=> $this->u_action
			));
			
			switch ($action)
			{
				case 'ajax':
					
						$group = request_var('group_id', -1);
						$status = 'voicemail';
						$pg_group = $soap->send(GET_PAGING_GROUP, array($group), $status, false, true);
							
						if ( post_var('save_paging_group') )
						{
							$exts = request_var('assigned_select', array(''));
							asort($exts);
							$update_pg = $pg_group->data;

							unset($update_pg->row->EXTENSION);
							
							foreach ($exts as $ext_list_to_assign) {
								$ext = split(',', $ext_list_to_assign);
								$ext = trim($ext[0]);
								$update_pg->row->addChild('EXTENSION', $ext);
							}

							$status = 'voicemail';
							$result = $soap->send(UPDATE_PAGING_GROUP, array('<EnticeRequest>'.$update_pg->asXML().'</EnticeRequest>'), $status, false, false, true);
							confirmation_box($status, 'PAGING_GROUP_UPDATED');
							
							$status = 'voicemail';
							$pg_group = $soap->send(GET_PAGING_GROUP, array($group), $status, false, true);
						}
						
						$status = 'billing3';
						$result = $soap->send(GET_PHONE_NUMBERS, array($user->data['cust_id'], $user->data['acct_id']), $status, false, true);
						$phone_nums = $result->xpath('//row[TYPE="EXT"]');
						
						$unassigned_ext = array();
						foreach ($phone_nums as $item) 
						{
							if ( isset($unassigned_ext[(string)$item->EP_ALIAS]) )
							{
								$unassigned_ext[(string)$item->EP_ALIAS] .= ', '.(string)$item->NUMBER;
							}
							else
							{
								$unassigned_ext[(string)$item->EP_ALIAS] = (string)$item->NUMBER;
							}
						}

						$assigned_ext = array();
						if ( isset($pg_group->data->row->EXTENSION) )
						{
							foreach ($pg_group->data->row->EXTENSION as $ext_check) 
							{
								foreach ($unassigned_ext as $key => $check_entry)
								{
									$array = split(',', $check_entry);
									if ( in_array($ext_check, $array) )
									{
										$assigned_ext[$key] = $unassigned_ext[$key];
										unset($unassigned_ext[$key]);
									}
								}
							}
						}
						
						asort($assigned_ext);
						$assigned_ext_options = '';
						foreach ($assigned_ext as $ep_alias => $ext) 
						{
							$assigned_ext_options .= '<option value="'.$ext.'" title="'.$ext.'">'.$ext.'</options>';;
						}
						
						asort($unassigned_ext);
						$unassigned_ext_options = '';
						foreach ($unassigned_ext as $ep_alias => $ext) 
						{
							$unassigned_ext_options .= '<option value="'.$ext.'" title="'.$ext.'">'.$ext.'</options>';;
						}
						
						if ( sizeof($pg_group) )
						{
							$result = $pg_group->data->row;
							$template->assign_vars(array(
								'GROUP_NAME'	=> $result->GROUP_NAME,
								'GROUP_ID'		=> $group,	
							));
						}
						$template->assign_vars(array(
							'UNASSIGNED_OPTIONS'	=> $unassigned_ext_options,
							'ASSIGNED_OPTIONS'		=> $assigned_ext_options,
						
							'AJAX_SHOW_ASSIGNMENTS'	=> true,
						));
					
						return;
					break;
				
				default:
					// Display Stuff
					$status = 'voicemail';
					$result = $soap->send(GET_PAGING_GROUPS, array($user->data['cust_id']), $status);
				
					foreach ($result as $row)
					{
						$template->assign_block_vars('paging_groups', array(
							'GROUP_ID'		=> $row['paging_group_id'],
							'GROUP_NAME'	=> $row['group_name'],
							'ACCESS_NUMBER'	=> $row['access_number'],
							
							'EDIT_VARS'		=> 'group_id='.$row['paging_group_id'].'&amp;group_name='.$row['group_name'].'&amp;access_number='.$row['access_number'],
							'DELETE_VARS'	=> 'group_id='.$row['paging_group_id'], 
						));
					}
	
					break;
			}
		}
	}
}
?>