<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: workgroups.php,v 1.10 2009/09/25 15:25:19 lsmith Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class workgroups
{
	public $u_action;

	private $ring_types = array (
		'2' => 'MULTI_RING',
		'3'	=> 'SEQUENTIAL_RING'
		//'4'	=> 'UCD'
	);
	
	function main($id, $mode)
	{
		global $user, $template, $soap, $reseller_user, $common_path, $phpEx;
		
		$action = request_var('action', '');
		$s_hidden_fields = '';
		
		$curr_ring_type = '';
		$timer = '';
		
		//validation of required field
		if (post_var('validate_data') )
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			$validate_ary = array(
				'description'			=> request_var('description',  ''),
			);
			$error = validate_data($validate_ary, array(
				'description'			=> array(
					array('string', false, 1, 128)),
			));
			return_error_data($error);
		}
		else
		{
			if ( post_var('add_workgroup') )
			{
				$wg_list = request_var('wg_list', array(''));
				sort($wg_list);
				for ($i = 1; $i < sizeof($wg_list)+1; $i++)
				{
					if ($wg_list[$i-1] != $i)
					{
						break;
					}
					if ( !isset($wg_list[$i]) )
					{
						$i++;
						break;
					}
				}
				$group_id = $i;
				$desc = request_var('description', '');
				$access_num = request_var('access_number', '');
				$ring_type = request_var('ring_type_select', 2);
				$queue_timer = request_var('queue_timer', 0);
				($queue_timer <= 0)? $queue_timer=900 : '';
				$alert_timer = request_var('alert_timer', 0);
				($alert_timer <= 0)? $alert_timer = 20 : '';
				($alert_timer > 99)? $alert_timer = 99 : '';
				$timer = $queue_timer*1000+$alert_timer;
				
				$wg_ary = array(
					$group_id,
					$user->data['cust_id'],
					$desc,
					$access_num,
					$ring_type,
					$timer
				);
				
				if ( $desc != '' )
				{
					$status = 'entice';
					$result = $soap->send(ADD_WORKGROUP, $wg_ary, $status, false, false, true);
					if (!isset($status['error']) || !$status['error'])
					{
						confirmation_box($status, 'WORKGROUP_ADDED');
						//@todo change for setting of rolling over to another wg, ext
						$vm_box = request_var('voicemail_box_select', '');
						if ( $vm_box != '' )
						{
							$dialed_number = $user->data['cust_id'].'_'.$access_num;
							$par = $this->get_vm_post_tran_id();
							if ( isset($par) )
							{
								$status = 'entice';
								$result = $soap->send(ADD_POST_TRAN_2, array($reseller_user, $par, 0, 0, $dialed_number, '',  $user->data['cust_id'].'_'.$vm_box, 'E-Pbx provisioned', '','', '', '',
													//@todo need to flag and parse $vm_box with flag to tell diff between vm and aa 
													is_numeric($vm_box) ? '' : 'W' , '', '', '', '', 0), $status);
								confirmation_box($status, 'MAILBOX_ATTACHED');
							}
						}
					}
					else 
					{
						confirmation_box($status, 'WORKGROUP_ERROR');
					}
				}
			}
			else if ( post_var('edit_workgroup') )
			{
				$group_id = request_var('group_id', -1);
				$desc = request_var('description', '');
				$access_orig = request_var('access_orig', '');
				$access_num = request_var('access_number', '');
				$ring_type = request_var('ring_type_select', 2);
				$queue_timer = request_var('queue_timer', 0);
				($queue_timer <= 0)? $queue_timer=900 : '';
				$alert_timer = request_var('alert_timer', 0);
				($alert_timer <= 0)? $alert_timer = 20 : '';
				($alert_timer > 99)? $alert_timer = 99 : '';
				$timer = $queue_timer*1000+$alert_timer;
				
				$status = 'entice';
				$result = $soap->send(UPDATE_WORKGROUP, array($group_id, $user->data['cust_id'], $desc, $access_orig, $access_num, $ring_type, $timer), $status, false, false, true);
				if (!isset($status['error']) || !$status['error'])
				{
					confirmation_box($status, 'WORKGROUP_UPDATED');
					if ($access_orig != '')
					{
						$dialed_number = $user->data['cust_id'].'_'.$access_orig;
						$par = $this->get_vm_post_tran_id();
						if ( isset($par) )
						{
							$status = 'entice';
							$result = $soap->send(DELETE_POST_TRAN, array($par, 0, 0, $dialed_number), $status, false, false, true);
						}
					}
					
					//@todo change for setting of rolling over to another wg, ext
					$vm_box = request_var('voicemail_box_select', '');
					if ( $vm_box != '')
					{
						$dialed_number = $user->data['cust_id'].'_'.$access_num;
						if ( isset($par) )
						{
							$status = 'entice';
							$result = $soap->send(ADD_POST_TRAN_2, array($reseller_user, $par, 0, 0, $dialed_number, '',  $user->data['cust_id'].'_'.$vm_box, 'E-Pbx provisioned', '','', '', '',
												 //@todo need to flag and parse $vm_box with flag to tell diff between vm and aa 
													is_numeric($vm_box) ? '' : 'W', '', '', '', '', 0), $status);
						}
					}
				}
				else 
				{
					confirmation_box($status, 'WORKGROUP_ERROR');
				}
			}
			else if ( post_var('save_wg_assign') ) {
				$group_id = request_var('group_id', -1);
				$ep_aliases = request_var('assigned_select', array(''));
				
				$status = 'entice';
				$result = $soap->send(SAVE_WG_EXTS, array($user->data['cust_id'], $group_id, $ep_aliases), $status, false, false, true);
				confirmation_box($status, 'WG_ASSIGN_SAVED');
			}
			else if ( post_var('delete_workgroup') )
			{
				$group_id = request_var('group_id', 0);
				$access_num = request_var('access_number', '');
				
				$wg_ary = array(
					$user->data['cust_id'],
					$group_id,
					$access_num,
				);
				
				$status = 'entice';
				$result = $soap->send(DELETE_WORKGROUP, $wg_ary, $status, false, false, true);
				confirmation_box($status, 'WORKGROUP_DELETED');
				if (!isset($status['error']) || !$status['error'])
				{
					$dialed_number = $user->data['cust_id'].'_'.$access_num;
					$par = $this->get_vm_post_tran_id();
					if ( isset($par) )
					{
						$status = 'entice';
						$result = $soap->send(DELETE_POST_TRAN, array($par, 0, 0, $dialed_number), $status, false, false, true);
					}
				}
			}
			
			
			
			switch ($action)
			{
				case 'show_assign':
					$group_id = request_var('group_id', -1);
					$display_name = request_var('display_name', '');
					
					$status = 'billing3';
					$result = $soap->send(GET_PHONE_NUMBERS, array($user->data['cust_id'], $user->data['acct_id']), $status, false, true);
					$result = $result->xpath('//row');
					
					$unassigned_ext = array();
					foreach ($result as $item) {
						if ( isset($unassigned_ext[(string)$item->EP_ALIAS]) )
						{
							$unassigned_ext[(string)$item->EP_ALIAS] .= ', '.(string)$item->NUMBER;
						}
						else
						{
							$unassigned_ext[(string)$item->EP_ALIAS] = (string)$item->NUMBER;
						}
					}
					
					$status = 'entice';
					$result = $soap->send(GET_WORKGROUP_EXT, array($user->data['cust_id'], $group_id), $status, false, false);
					$assigned_ext = array();
					foreach ($result as $ep_return) {
						if ( isset($unassigned_ext[$ep_return['ep_alias']]) )
						{
							$assigned_ext[$ep_return['ep_alias']] = $unassigned_ext[$ep_return['ep_alias']];
							unset($unassigned_ext[$ep_return['ep_alias']]);
						}
					}
					
					asort($assigned_ext);
					$assigned_ext_options = '';
					foreach ($assigned_ext as $ep_alias => $ext) 
					{
						$assigned_ext_options .= '<option value="'.$ep_alias.'" title="'.$ext.'">'.$ext.'</options>';;
					}
					
					asort($unassigned_ext);
					$unassigned_ext_options = '';
					foreach ($unassigned_ext as $ep_alias => $ext) {
						$unassigned_ext_options .= '<option value="'.$ep_alias.'" title="'.$ext.'">'.$ext.'</options>';;
					}
					
					$template->assign_vars(array(
						'AJAX_ASSIGN_WORKGROUP' => true,
					
						'UNASSIGNED_OPTIONS'	=> $unassigned_ext_options,
						'ASSIGNED_OPTIONS'		=> $assigned_ext_options,
					
						'WG_NAME'				=> $display_name,
						'WG_ID'					=> $group_id,
					));
					break;
				
				default:
					// Display Stuff
					$status = 'entice';
					$result = $soap->send(GET_WORKGROUPS, array($user->data['cust_id']), $status);
				
					$wg_list = array();
					$par = $this->get_vm_post_tran_id();
					foreach ($result as $row)
					{
						// Check for voicemail
						$vm_num=$user->data['cust_id'].'_'.$row['dialed_number'];
						$vm_box = '';
						if (isset($par) )
						{
							$status='entice';
							$vm_result=$soap->send(GET_POST_TRAN, array($par, 0, 0, $vm_num), $status, false, true, true);
							if (!isset($vm_result->error) || !$vm_result->error)
							{
								$vm_box = $vm_result->data->row->TRANSLATED_NUMBER;
							}
						}
						
						$queue_timer =  substr($row['timer'],0,strlen($row['timer'])-3);
						$alert_timer = (int)substr((string) $row['timer'],-3);
						
						//@todo change for setting of rolling over to another wg, ext
//						$split = split('_', $vm_box);
//						isset($split[1])? $m_ext = $split[1]: $m_ext = '';
						$index = stripos($vm_box,'_');
						$index > 0 ? $m_ext = substr($vm_box, $index + 1) : $m_ext = '';
						$template->assign_block_vars('workgroups', array(
							'GROUP_ID'		=> $row['group_id'],
							'DESCRIPTION'	=> $row['s_desc'],
							'ACCESS_NUMBER'	=> $row['dialed_number'],
							'RING_TYPE'		=> $user->lang[$this->ring_types[$row['feature']]],
							'QUEUE_TIMER'	=> $queue_timer,
							'ALERT_TIMER'	=> $alert_timer,
							'MAILBOX_EXT'	=> $m_ext,
							
							'EDIT_VARS'		=> 'group_id='.$row['group_id'].'&amp;description='.$row['s_desc'].'&amp;access_number='.$row['dialed_number'].'&amp;ring_type_select='.$row['feature'].'&amp;queue_timer='.$queue_timer.'&amp;alert_timer='.$alert_timer.'&amp;access_orig='.$row['dialed_number'].'&amp;voicemail_box_select='.$m_ext,
							'DELETE_VARS'	=> 'group_id='.$row['group_id'].'&amp;access_number='.$row['dialed_number'], 
						));
						
						$wg_list[] = $row['group_id'];
					}
	
					//@todo change for setting of rolling over to another wg, ext
					$status = 'billing3';
					$result = $soap->send(GET_PHONE_NUMBERS, array($user->data['cust_id'], $user->data['acct_id']), $status, false, true);
					$result = $result->xpath('//row[TYPE = "EXT" and hasMailBox = "true"]');
					$vm_ext_options = '<option value="">'.$user->lang['NONE'].'</option>';	
					if (sizeof($result) > 0) {
						$vm_ext_options .= '<optgroup label='.$user->lang['VOICEMAIL'].'></optgroup>';	
						foreach ($result as $row) {
							$vm_ext_options .= '<option value="'.$row->NUMBER.'" >' . $row->NUMBER . '</option>';
						}
					}
					$status = 'voicemail';
					$result = $soap->send(GET_AA_MENU_LIST, array($user->data['cust_new_id']), $status, false, true);
					$result = $result->xpath('//row');
					if (sizeof($result) > 0) {
						$vm_ext_options .= '<optgroup label='.$user->lang['AUTOATTENDANTS'].'></optgroup>';	
						foreach ($result as $row) {
							$vm_ext_options .= '<option value="'.$row->DIALOGNAME.'" >' . $row->DIALOGNAME . '</option>';
						}
					}
									
					$template->assign_vars(array(
						'VOICEMAIL_BOX_OPTIONS' => $vm_ext_options,
					));
					break;
			}
			$s_hidden_fields .= build_hidden_fields(array(
				'wg_list[]'			=> $wg_list,
				'group_id'			=> '',
				'display_name'		=> '',
				'delete_workgroup'	=> '',
				'access_orig'		=> '',
			));
			
			$template->assign_vars(array(
				'RING_TYPE_OPTIONS'	=> $this->gen_ring_type_options($curr_ring_type),
			
				'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
				
				'U_SHOW_ASSIGN_BOX'	=> $this->u_action.'&amp;action=show_assign', 
				'U_ACTION'			=> $this->u_action
			));
		}
	}

	function get_vm_post_tran_id()
	{
		global $user, $soap;
		$user_id = get_soap_user_id();
		
		$status = 'entice';
		$vm_rl_id = $soap->send(GET_VOICEMAIL_RTLST, array(), $status, true);
		$vm_rl_id = $vm_rl_id->returnStatus;
		if(!isset($vm_rl_id)) {//if getVoiceMailRouteListId failed return null
			return null;
		}
		
		$status = 'entice';
		$rl_id_obj = $soap->send(GET_ROUTE_LIST, array($user_id, $vm_rl_id), $status, false, true);
		if(!isset($rl_id_obj->error)) {
			$rl_id_obj = (int)$rl_id_obj->data->row->ROUTE_LIST_ID;
		}
		if(!isset($rl_id_obj)) {//if getRouteListId failed return null
			return null;
		}
		
		$status = 'entice';
		$rg_obj = $soap->send(GET_RESOURCE_GROUP, array($rl_id_obj), $status, false, true);
		if(!isset($rl_id_obj->error)) {
			$rg_obj = (int)$rg_obj->data->row->POSTTRAN_ID;
		}
		if(!isset($rg_obj)) {//if getResourceGroup failed return null
			return null;
		}
		return $rg_obj;
	}
	
	function gen_voicemail_box_options($current = '')
	{
		global $user, $soap;
		
		$split = split('_', $current);
		if ( isset($split[1]) )
		{
			$current = $split[1];
		}
		$status = 'entice';
		$result = $soap->send(GET_TRANS_BY_PART, array($user->data['cust_id']), $status, false, false, true);
		
		foreach ($result as $row)
		{
			trigger_error(print_r($row, false));
			
		}
		
		$options = '';
		foreach ($this->ring_types as $value => $lang) {
		}
		
		return $options;
	}
	
	function gen_ring_type_options($current = '')
	{
		global $user;
		
		$options = '';
		foreach ($this->ring_types as $value => $lang) {
			$options .= '<option value="'.$value.'" '.(($current == $value)?'selected':'').'>' . $user->lang[$lang] . "</option>";
		}
		
		return $options;
	}
}
?>