<?php
/**
*
* common [English]
*
* @author Lance Smith
* @package common modules
* @version $Id: aniClass.php,v 1.2 2011/03/21 21:51:24 lor Exp $
* @copyright (c) 2007-20010 Stratus Technologies
* @license Stratus Telecom
*
*/

require_once ($GLOBALS['common_path'] . 'includes/page.php');

class aniClass {

	private $u_action = '';
	private $cust_Id = '';
	private $acct_id = '';
	
	public function __construct($u_action, $cust_Id, $acct_Id = '') {
		$this->u_action = $u_action;
		$this->cust_Id = $cust_Id;
		$this->acct_id = $acct_Id;		
	}
	
	
	/**
	 *     &lt;data&gt;
     *       &lt;row&gt;
     *          &lt;SUBSCRIBER_ID&gt;123456789&lt;/SUBSCRIBER_ID&gt;
     *          &lt;ANI&gt;
     *                &lt;NUMBER&gt;1111111111&lt;/NUMBER&gt;
     *                &lt;PIN&gt;111&lt;/PIN&gt;
     *         &lt;/ANI&gt;
     *         &lt;ANI&gt;
     *                &lt;NUMBER&gt;2222222222&lt;/NUMBER&gt;
     *                &lt;PIN&gt;222&lt;/PIN&gt;
     *         &lt;/ANI&gt;
     *       &lt;/row&gt;
     *     &lt;/data&gt;
	 * @param unknown_type $sub_id -> subscriber id from user_def
	 * @param unknown_type $action -> what action to take with this call
	 */
	public function doCrude($sub_id, $action){
		
		switch ($action) {
			case 'ani_add_maint':
				$data = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
				$req = $data->addChild("data");
				$row = $req->addChild('row');
				$row->addChild( "SUBSCRIBER_ID", $sub_id) ;
				$ani= $row->addChild('ANI');
				$ani->addChild( "NUMBER", request_var('number','')) ;
				$ani->addChild( "PIN", request_var('pin','')) ;
				
				$status='billing3';
				$result = Page::send(ADD_ANI_TO_SUBSCRIBER,$data, $status, true);
				confirmation_box($status, 'ANI_ADDED', request_var('number',''));
				
				$action = 'ani_display';
				break;
				
			case 'ani_delete':
				$data = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
				$req = $data->addChild("data");
				$row = $req->addChild('row');
				$row->addChild( "SUBSCRIBER_ID", $sub_id) ;
				$ani= $row->addChild('ANI');
				$ani->addChild( "NUMBER", request_var('number','')) ;
				//$ani->addChild( "PIN", request_var('pin','')) ;
				
				$status='billing3';
				$result = Page::send(DELETE_ANI_FROM_SUBSCRIBER, $data, $status, true);
				confirmation_box($status, 'ANI_DELETED', request_var('number',''));
				
				$action = 'ani_display';
				break;
		}
		
		return $action;
	}
	
	public function doDisplay($sub_id, $action) {
		global $template, $soap;
		//trigger_error("we are here (" . $action .").");
		//Page::makeSelectOptions();
		$action = $this->doCrude($sub_id, $action);
		
		switch ($action) {
			case 'ani_add':
				//trigger_error("ani_add are here (" . $action .").");
				$template->assign_vars(array(
						'U_ANI_ADD_MAINT' => $this->u_action . "&amp;action=ani_add_maint",
						'SUB_ANI_ADD'	=> true,
					));
				break;
			default:
				$filter = 'SUBSCRIBER_ID|=|'.$sub_id.'|TYPE|=|ANI';
				$status = 'billing3';
				$result = $soap->send(GET_PHONE_NUMBERS, array($this->cust_Id, $this->acct_id, $filter), $status);
				//trigger_error(print_r($result));
				foreach ($result as $row) {
					$row['U_ANI_DELETE'] = $this->u_action 
							. "&amp;number=".$row['number'] 
							. "&amp;action=ani_delete" ;
					display_vars($row,'anis');
				}
				break;
		}
		$template->assign_vars(array(
				'U_ANI_ADD' 	=> $this->u_action . "&amp;action=ani_add",
				'U_ANI_DISPLAY' => $this->u_action . "&amp;action=ani_display",
				'SUB_ANI_AJAX'	=> true,
			));
	}
}
?>